000010 IDENTIFICATION DIVISION.
000020 PROGRAM-ID. TPROGBAR.
000030 DATE-COMPILED.
000040* ------------------------: GS General-purpose Test Program.
000050* 			: Use to test any GUI ScreenIO panel...
000060*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
000070 ENVIRONMENT DIVISION.
      * 040705ja-7 Corrected sequence of string command 		040705ja
000080*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
000090 CONFIGURATION SECTION.
000100 SOURCE-COMPUTER. IBM-PC.
000110 OBJECT-COMPUTER. IBM-PC.
000120*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
000130 DATA DIVISION.
000140*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
000150 WORKING-STORAGE SECTION.
       01  V--VERSION-LEVEL PIC 9(3) VALUE 7.				040705ja
000170*
000180* ------------------------: Copy a main panel (any will do)
000190	       COPY mymain.
000200*
000210* ------------------------: Copy the panel to be tested below.
000220	       COPY P-OPENSA.
000230* 			: Copybooksfor OpenSave API
000240	       COPY WIN32API.
000250	       COPY OPENSAVE.
000260*
000270* 			: Constants used with OPENSAVE
000280*
000380*
000390*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
000400 PROCEDURE DIVISION.
000410*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
000420*
000430	   PERFORM 0101-INITIALIZE-GS.
000440*
000450* ------------------------: Display the test panel.
000460*
000470	   PERFORM WITH TEST AFTER
000480		 UNTIL P-OPENSA-EVENT-CLOSE-WINDOW
000490		 OR P-OPENSA-EVENT-CLOSE-AND-STOP
000500*
000510	     IF P-OPENSA-GET-FILESPEC
000520	       PERFORM 0102-OPENSAVE-DIALOG
000530	     END-IF
000540*
000550	     CALL 'GS' USING P-OPENSA-1
000560			     P-OPENSA-2
000570			     P-OPENSA-3
000580			     P-OPENSA-4
000590*
000600	   END-PERFORM.
000610*
000620* ------------------------: Close the main before doing a STOP RUN
000630*
000640	   SET mymain-DO-CLOSE TO TRUE.
000650	   CALL 'GS' USING mymain-1
000660			   mymain-2
000670			   mymain-3
000680			   mymain-4.
000690	   STOP RUN.
000700*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
000710 0100-GS-UTILITY SECTION.
000720*
000730 0101-INITIALIZE-GS.
000740* 			:---------------------------------------
000750* ------------------------: Open the application window (the
000760* 			: container for this application)
000770* 			:---------------------------------------
000780*
000790	   CALL 'GS' USING mymain-1
000800			   mymain-2
000810			   mymain-3
000820			   mymain-4.
000830* -====-
000840 0102-OPENSAVE-DIALOG.
000850* ------------------------: Load the dialog title and text.
000860*
000870	   STRING 'My Open/SaveAs Dialog Title'
000880	       LOW-VALUE DELIMITED SIZE INTO OPENSAVE-WINDOW-TITLE.
000890*
000900* ------------------------: Load the default extension of the
000910* 			: files we're looking for.
000920*
000930	   STRING 'INI' DELIMITED SIZE
000940	       LOW-VALUE DELIMITED SIZE INTO OPENSAVE-DEFAULT-EXTENSION.
000950*
000960* ------------------------: Set the flag bits by adding the
000970* 			: values, giving OPENSAVE-FLAGS.
000980*
000990	   ADD OFN-EXPLORER
001000	       OFN-FILEMUSTEXIST
001010	       OFN-PATHMUSTEXIST
001020	       OFN-HIDEREADONLY
001030		  GIVING OPENSAVE-FLAGS.
001040*
001050* ------------------------: Load the window handle of the window
001060* 			: that will own this dialog; (it's
001070* 			: passed back by GUI ScreenIO when you
001080* 			: display a panel).
001090*
001100	   MOVE P-OPENSA-HWND TO OPENSAVE-HWNDOWNER.
001110*
001120* ------------------------: Load the size of the CUSTOMFILTER area
001130* 			: Note:  We don't presently use this
001140* 			: facility...
001150*
001160	   MOVE LOW-VALUE TO OPENSAVE-CUSTOMFILTER
001170			     OPENSAVE-FILENAME.
001180*
001190	   MOVE LENGTH OF OPENSAVE-CUSTOMFILTER
001200	       TO OPENSAVE-LENGTH-CUSTFILTER.
001210*
001220* ------------------------: Size of the FILESPEC buffer
001230*
001240	   MOVE LENGTH OF OPENSAVE-FILESPEC
001250	       TO OPENSAVE-LENGTH-FILESPEC.
001260*
001270* ------------------------: Size of the FILENAME buffer
001280*
001290	   MOVE LENGTH OF OPENSAVE-FILENAME
001300	       TO OPENSAVE-LENGTH-FILENAME.
001310*
001320* ------------------------: Initial directory
001330*
001340	   STRING 'C:\'
001350	       LOW-VALUE DELIMITED SIZE INTO OPENSAVE-INITIALDIR.
001360*
001370* ------------------------: Index of the current filter in
001380* 			: OPENSAVE-INITIALFILTER; in this case,
001390* 			: it will be "*.ini".
001400*
001410	   MOVE 1 TO OPENSAVE-FILTER-INDEX.
001420*
001430* ------------------------: Load pairs of null-terminated strings
001440* 			: specifying the filter to use:
001450* 			:
001460* 			: First  element is name of the filter
001470* 			: Second element is the filter pattern
001480* 			: Last one is terminated with two nulls.
001490*
001500	   STRING
001510	       'All Files (*.*)' LOW-VALUE '*.*' LOW-VALUE
001520	       'Application Profiles (*.INI)' LOW-VALUE '*.ini'         040705ja
001530	       LOW-VALUE						040705ja
001540	       LOW-VALUE DELIMITED SIZE INTO OPENSAVE-FILTER.
001550*
001560* ------------------------: Select the API to use:
001570*
001580	   SET API-GETOPENFILENAME TO TRUE.
001590*
001600* ------------------------: Call the GUI ScreenIO API routine:
001610*
001620	   CALL 'GSWINAPI' USING WIN32API-PARMS                         011130kh
001630				 OPENSAVE-PARMS 			011130kh
001640				 OPENSAVE-INITIALDIR			011130kh
001650				 OPENSAVE-FILTER			011130kh
001660				 OPENSAVE-CUSTOMFILTER			011130kh
001670				 OPENSAVE-FILESPEC			011130kh
001680				 OPENSAVE-FILENAME.			011130kh
001690*
001700	   IF WIN32API-FAILED OR OPENSAVE-FILESPEC NOT > SPACE
001710	     SET P-OPENSA-MESSAGE-BAR-BEEP TO TRUE
001720	     MOVE WIN32API-ERROR-TEXT TO P-OPENSA-MESSAGE-TEXT
001730	   ELSE
001740	     MOVE OPENSAVE-OFFSET-FILENAME TO DISPLAY-OFFSET-FILENAME
001750	     MOVE OPENSAVE-OFFSET-FILEEXT TO DISPLAY-OFFSET-FILEEXT
001760	     MOVE OPENSAVE-FILESPEC TO DISPLAY-FILESPEC
001770	     MOVE OPENSAVE-FILENAME TO DISPLAY-FILENAME.
